--[[

-- Original version of this file by Dahk Celes (DDCorkum).
-- Included with permission in WoWAccess by RogueEugor (A. Agostino).

-- If you change this file, please be kind and mark changes clearly

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

--]]
-- To be rewritten as part of the Keyboard UI addon soon
if KeyboardUI and KeyboardUI.tooltips then
    return
end
local tooltipTicker
local cursorChanged
local canPlay = true
local oldText

local function resetCursorIfNoTooltip()
	if not tooltipTicker then
		cursorChanged = false
	end
end

local function monitorTooltip()
	local newText = GameTooltipTextLeft1:GetText()
	if canPlay and newText ~= oldText and cursorChanged and GetMouseFocus() == WorldFrame then
		oldText = newText
		cursorChanged = false
		C_VoiceChat.SpeakText(0, newText, 4, 5, 30)
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("CURSOR_UPDATE")
frame:RegisterEvent("VOICE_CHAT_TTS_PLAYBACK_STARTED")
frame:RegisterEvent("VOICE_CHAT_TTS_PLAYBACK_FINISHED")
frame:SetScript("OnEvent", function(__, event)
	if event == "CURSOR_UPDATE" then
		if GetMouseFocus() == WorldFrame then
			cursorChanged = true
			PlaySound(823)
			C_Timer.After(0, resetCursorIfNoTooltip)
		end
	elseif event == "VOICE_CHAT_TTS_PLAYBACK_STARTED" then
		canPlay = false
	elseif event == "VOICE_CHAT_TTS_PLAYBACK_FINISHED" then
		canPlay = true
	end
end)

GameTooltip:HookScript("OnShow", function()
	tooltipTicker = tooltipTicker or C_Timer.NewTicker(0.5, monitorTooltip)
end)

GameTooltip:HookScript("OnHide", function()
	if tooltipTicker then
		tooltipTicker:Cancel()
		tooltipTicker = nil
	end
end)
