local __, addon = ...

local isTtsQuiet, isTalkingHeadQuiet = true, true
local currentMessage = nil

local frame = CreateFrame("Frame")
frame:RegisterEvent("VOICE_CHAT_TTS_PLAYBACK_STARTED")
frame:RegisterEvent("VOICE_CHAT_TTS_PLAYBACK_FINISHED")
frame:RegisterEvent("VOICE_CHAT_TTS_PLAYBACK_FAILED")
frame:SetScript("OnEvent", function(__, event)
    if event == "VOICE_CHAT_TTS_PLAYBACK_STARTED" then
        isTtsQuiet = false
    elseif event == "VOICE_CHAT_TTS_PLAYBACK_FINISHED" then
        isTtsQuiet = true
        currentMessage = nil
    elseif event == "VOICE_CHAT_TTS_PLAYBACK_FAILED" then
        isTtsQuiet = true
        currentMessage = nil
    end
end)

if TalkingHeadFrame then
    TalkingHeadFrame:HookScript("OnShow", function()
        isTalkingHeadQuiet = false
    end)
    
    TalkingHeadFrame:HookScript("OnHide", function()
        isTalkingHeadQuiet = true
    end)
end

function addon.speakText(text)
    if text and text ~= "" then
        C_VoiceChat.StopSpeakingText()
        if C_TTSSettings then
        	C_VoiceChat.SpeakText(C_TTSSettings.GetVoiceOptionID(0) or 0, text, 4, C_TTSSettings.GetSpeechRate() or 5, C_TTSSettings.GetSpeechVolume() or 100)
        else
        	C_VoiceChat.SpeakText(0, text, 4, 5, 100)
        end
        print(text)
        currentMessage = text
    end
end

function addon.speakTextIfQuiet(text)
    if isTtsQuiet and isTalkingHeadQuiet and text and text ~= "" then
        if C_TTSSettings then
        	C_VoiceChat.SpeakText(C_TTSSettings.GetVoiceOptionID(0) or 0, text, 4, C_TTSSettings.GetSpeechRate() or 5, C_TTSSettings.GetSpeechVolume() or 100)
        else
        	C_VoiceChat.SpeakText(0, text, 4, 5, 100)
        end
        print(text)
        currentMessage = text
        return true
    end
    return false
end