_, ADDON = ...
local speakText = ADDON.speakText
local speakTextIfQuiet = ADDON.speakTextIfQuiet

ADDON.BeaconLib = LibStub("SkuBeacon-1.0"):Create("WOWAccess", false)

local soundSet
for __, setBaseName in ADDON.BeaconLib:GetSoundSets() do
	if setBaseName == "probe_deep_1click" then
		soundSet = "probe_deep_1click"
	end
end

if not soundSet then
	soundSet = "probe_deep_1_near_click"
	ADDON.BeaconLib:RegisterSoundSet("probe_deep_1_near_click","Interface\\AddOns\\WoWAccess\\libs\\probe_deep_1_modified", 10, 7, "probe_deep_1", "click_fast.mp3", "clack_Fast.mp3")
end

local currentBeacon
local selectedLocation = 1
local useOtherMap = false
local selectedMap = 1
local currentZone = "Hello"


local function saveLocation(data1)
	local map = C_Map.GetBestMapForUnit("player")
	if( map ) then
		currentZone = GetSubZoneText()
		local position = C_Map.GetPlayerMapPosition(map, "player")
		if (position) then
			local playerMapX, playerMapY = position:GetXY()
			playerMapX = math.floor(playerMapX*10000+0.5)/100
			playerMapY = math.floor(playerMapY*10000+0.5)/100
			local globX, globY = UnitPosition("player")
			if not tContains(locationMemoryCountNew, map) then
				tinsert(locationMemoryCountNew, map)
			end
			local newPin = {
				lX= playerMapX,
				lY = playerMapY,
				globalX = globX,
				globalY = globY,
				locationName= data1,
				zoneName = currentZone,
			}
			locationMemoryNew[map] = locationMemoryNew[map] or {}
			tinsert(locationMemoryNew[map], newPin)
			C_Timer.After(.5, function() 
				local n = #locationMemoryNew[map]
				local entry = locationMemoryNew[map][n].locationName..", saved at "..locationMemoryNew[map][n].zoneName..", "..locationMemoryNew[map][n].lX..", "..locationMemoryNew[map][n].lY.."."
				speakText(entry)
				local beaconEntry = map.." "..currentZone.." "..data1
			end)
			--need to speak a message that references this data for testing. Update the prev and next, as well as the read functions. Then apply functions to create, activate, and deactivate, as well as destroy beacons for these saved locations.
		end
	end
end

local function getSaveLocationName()
StaticPopup_Show("WOWA-LOCATIONMEMORYINFO")
end

local function readSlocation()
	selectedMap = Clamp(selectedMap, 1, #locationMemoryCountNew)
	local map = useOtherMap and locationMemoryCountNew[selectedMap] or C_Map.GetBestMapForUnit("player")
	print(map)
	if map and locationMemoryNew[map] then
		selectedLocation = Clamp(selectedLocation, 1, #locationMemoryNew[map])
		local entry = locationMemoryNew[map][selectedLocation].locationName..", saved at "..locationMemoryNew[map][selectedLocation].zoneName..", "..locationMemoryNew[map][selectedLocation].lX..", "..locationMemoryNew[map][selectedLocation].lY.."."
		speakText(entry)
	end
end

local function selectNextLocation()
	selectedLocation = selectedLocation + 1
	readSlocation()
end

local function selectPrevLocation()
	selectedLocation = selectedLocation - 1
	readSlocation()
end

local function selectNextMap()
	selectedMap = selectedMap + 1
	useOtherMap = true
	readSlocation()
end

local function selectPrevMap()
	selectedMap = selectedMap - 1
	useOtherMap = true
	readSlocation()
end

local function mapRevert()
	useOtherMap = false
	selectedMap = 1
	C_Timer.After(300, mapRevert)
end

local function deactivateBeacon()
	if currentBeacon then
		ADDON.BeaconLib:StopBeacon("WOWAccess", currentBeacon)
		ADDON.BeaconLib:DestroyBeacon("WOWAccess", currentBeacon)
		currentBeacon = nil
		return true
	end
	return false
end

local function activateBeacon()
	local map = useOtherMap and locationMemoryCountNew[selectedMap] or C_Map.GetBestMapForUnit("player")
	if map and locationMemoryNew[map] then
		selectedLocation = selectedLocation or 1
		local thisName = locationMemoryNew[map][selectedLocation].locationName
		local thisZone = locationMemoryNew[map][selectedLocation].zoneName
		local globX = locationMemoryNew[map][selectedLocation].globalX
		local globY = locationMemoryNew[map][selectedLocation].globalY
		local entry = map.." "..thisZone.." "..thisName
		if currentBeacon ~= entry then
			deactivateBeacon()
			currentBeacon = entry
			ADDON.BeaconLib:CreateBeacon("WOWAccess", entry, soundSet, globX, globY, -3, 0, 100, 10)
			ADDON.BeaconLib:StartBeacon("WOWAccess", entry)
			return true
		end
	end
	return false
end


local frame = CreateFrame("Frame")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PLAYER_ALIVE")
frame:RegisterEvent("PLAYER_UNGHOST")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, arg1)
	if (event == "ADDON_LOADED" and arg1 == "WOWAccess") then
		locationMemoryNew = locationMemoryNew or {}
		locationMemoryCountNew = locationMemoryCountNew or {}
	elseif (event == "PLAYER_ENTERING_WORLD" ) then
		C_Timer.After(2, mapRevert)
	elseif (event == "PLAYER_UNGHOST") and currentBeacon == "Corpse_Beacon" then
		deactivateBeacon()
	elseif (event == "PLAYER_LOGIN") then
		SetBindingClick("ALT-S", "SaveLocation")
		SetBindingClick("ALT-E", "ActivateBeacon")
		SetBindingClick("ALT-Q", "DeactivateBeacon")
		SetBindingClick("ALT-W", "SelectNextMap")
		SetBindingClick("ALT-A", "SpeakPrevLocation")
		SetBindingClick("ALT-D", "SpeakNextLocation")
		SetBindingClick("ALT-X", "SelectPrevMap")
		SetBindingClick("ALT-C", "CorpseBeaconToggle")
	end
end)

CreateFrame("BUTTON", "SaveLocation"):SetScript("OnClick", function(self, BUTTON, down)
	getSaveLocationName()
end)

CreateFrame("BUTTON", "ActivateBeacon"):SetScript("OnClick", function(self, BUTTON, down)
	if activateBeacon() then
		speakText("Activating beacon")
	end
end)

CreateFrame("BUTTON", "DeactivateBeacon"):SetScript("OnClick", function(self, BUTTON, down)
	if deactivateBeacon() then
		speakText("Deactivating beacon")
	end
end)

CreateFrame("BUTTON", "SelectNextMap"):SetScript("OnClick", function(self, BUTTON, down)
	selectNextMap()
end)

CreateFrame("BUTTON", "SpeakPrevLocation"):SetScript("OnClick", function(self, BUTTON, down)
	selectPrevLocation()
end)

CreateFrame("BUTTON", "SpeakNextLocation"):SetScript("OnClick", function(self, BUTTON, down)
	selectNextLocation()
end)

CreateFrame("BUTTON", "SelectPrevMap"):SetScript("OnClick", function(self, BUTTON, down)
	selectPrevMap()
end)

CreateFrame("BUTTON", "CorpseBeaconToggle"):SetScript("OnClick", function(self, BUTTON, down)
	local playerMap = C_Map.GetBestMapForUnit("player")
	local corpsePos = C_DeathInfo.GetCorpseMapPosition(playerMap)
	local corpseX = nil
	local corpseY = nil
	local continentID = nil
	local worldPosition  = nil
	if(corpsePos ~= nil) then 
		continentID, worldPosition = C_Map.GetWorldPosFromMapPos(playerMap, corpsePos)
		corpseX, corpseY = worldPosition:GetXY(worldPosition)
	end
	if(corpsePos ~= nil) then
		if (currentBeacon == "Corpse_Beacon") then
			deactivateBeacon()
		else
			if (currentBeacon) then
				deactivateBeacon()
			end
			ADDON.BeaconLib:CreateBeacon("WOWAccess", "Corpse_Beacon", soundSet, corpseX, corpseY, -3, 0, 100, 10)
			ADDON.BeaconLib:StartBeacon("WOWAccess", "Corpse_Beacon")
			currentBeacon = "Corpse_Beacon"
		end
	else
		speakText("there's no corpse available to beacon.")
	end
end)

StaticPopupDialogs["WOWA-LOCATIONMEMORYINFO"] = {
  text = "What is the name of the new location memory?",
  button1 = ACCEPT,
  button2 = CANCEL,
    EditBoxOnEnterPressed = function(self)
        self:GetParent().button1:Click();

    end,
    EditBoxOnEscapePressed = function(self)
        self:GetParent().button2:Click();
speakText("Canceled")
    end,

OnAccept = function (self, data, data2)
    local text = self.editBox:GetText()
saveLocation(text)
end, 
timeout = 0,

hasEditBox = true,
--enterClicksFirstButton = true,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,  
}
